<template>
      <b-table
      :data="policies"
      :paginated="true"
      :per-page="20"
      detailed
      detail-key="id"
      default-sort="provider"
      >
      <b-table-column field="id" label="ID" width="30%" sortable v-slot="props">
        <span class="is-size-7">
          {{ props.row['@id'].split('/').pop() }}
        </span>
      </b-table-column>
      <b-table-column field="provider" width="20%" label="Provider" sortable v-slot="props">
        <template v-if="props.row['ids:provider']">
        {{ props.row['ids:provider']['@id'] }}
        </template>
        <template v-else>*</template>
      </b-table-column>
      <b-table-column field="consumer" width="20%" label="Consumer" sortable v-slot="props">
        <template v-if="props.row['ids:consumer']">
        {{ props.row['ids:consumer']['@id'] }}
        </template>
        <template v-else>*</template>
      </b-table-column>
      <b-table-column field="date" width="20%" label="Date" sortable v-slot="props">
        {{ props.row['ids:contractStart']['@value'] | formatDate }} - <template v-if="props.row['ids:contractEnd']">{{ props.row['ids:contractEnd']['@value'] | formatDate }}</template><template v-else>*</template>
      </b-table-column>
      <b-table-column field="delete" width="10%" label="Actions" v-slot="props" v-if="actions">
        <b-button type="is-danger"
            icon-right="delete"
            @click="$emit('delete', props.row['@id'])" />
      </b-table-column>
      <b-table-column field="decision" width="10%" label="Decision" v-slot="props" v-if="decision">
        {{ props.row['decision'] }}
      </b-table-column>
      <template #empty v-if="decision">
        <p class="has-text-centered">No suitable policy found, by default no access is allowed</p>
      </template>
      <template #detail="props">
        <b-table
          :data="policyRules(props.row)"
          striped
          >
          <b-table-column field="assigner" label="Assigner" width="15%" sortable v-slot="rule">
            <template v-if="rule.row['ids:assigner'] && rule.row['ids:assigner'][0]">
            {{ rule.row['ids:assigner'][0]['@id'] }}
            </template>
            <template v-else>*</template>
          </b-table-column>
          <b-table-column field="assigner" label="Assignee" width="15%" sortable v-slot="rule">
            <template v-if="rule.row['ids:assignee'] && rule.row['ids:assignee'].length">
            <span v-for="assignee in rule.row['ids:assignee']" :key="assignee['@id']">{{ assignee['@id'] }}</span>
            </template>
            <template v-else>*</template>
          </b-table-column>
          <b-table-column field="target" label="Path" width="45%" sortable v-slot="rule">
            <template v-if="!rule.row">{{ rule.row }}</template>
            <template v-else-if="rule.row['ids:target']['@id'].startsWith('urn:ids:regex:')">
              <b-field grouped group-multiline>
                <div class="control">
                  <b-taglist attached>
                    <b-tag type="is-dark">Version</b-tag>
                    <b-tag :type="`${(rule.row['@type'] === 'ids:Permission') ? 'is-success' : 'is-danger'}`">{{ rule.row['ids:target']['@id'].replace('urn:ids:regex:/','').split('/')[0] }}</b-tag>
                  </b-taglist>
                </div>
                <div class="control">
                  <b-taglist attached>
                    <b-tag type="is-dark">Path</b-tag>
                    <b-tag :type="`${(rule.row['@type'] === 'ids:Permission') ? 'is-success' : 'is-danger'}`">/{{ rule.row['ids:target']['@id'].replace('urn:ids:regex:/','').split('/').slice(1).join("/") }}</b-tag>
                  </b-taglist>
                </div>
              </b-field>
            </template>
            <template v-else>
              <b-tag :type="`${(rule.row['@type'] === 'ids:Permission') ? 'is-success' : 'is-danger'}`">
                  {{ rule.row['ids:target']['@id'].replace('urn:ids:regex:','') }}
              </b-tag>
            </template>
          </b-table-column>
          <b-table-column field="methods" label="Methods" width="25%" sortable v-slot="rule">
            <b-taglist>
             <b-tag v-for="method in mapActionToMethod(rule.row)" :key="method.method" :type="`${method.type}`">{{ method.method }}</b-tag>
            </b-taglist>
          </b-table-column>
          <b-table-column field="decision" label="Decision" width="10%" sortable v-slot="rule" v-if="decision">
            {{ rule.row.decision }}
          </b-table-column>
        </b-table>
      </template>
    </b-table>
</template>

<script lang="ts">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'
import moment from 'moment-timezone';

@Component({
  filters: {
    formatDate: (date: Date): string => {
      return moment(date).tz(moment.tz.guess()).format('YYYY-MM-DD')
    }
  }
})
export default class PolicyTable extends Vue {
  @Prop({required: true})
  policies!: Array<any>

  @Prop({required: false, default: true})
  actions!: boolean

  @Prop({required: false, default: false})
  decision!: boolean

  policyRules(policy: any): Array<any> {
    return (policy['ids:permission'] || []).concat(policy['ids:prohibition'] || [])
  }

  mapActionToMethod(policy: any): Array<{method: string, type: string}> {
    const actions: Array<any> = policy?.['ids:action'] || []
    return actions.map((action) => {
      switch (action['@id']) {
        case 'https://w3id.org/idsa/code/READ':
          return [{ method: 'GET', type: 'is-info' }, { method: 'HEAD', type: 'is-info' }, { method: 'OPTIONS', type: 'is-info' }, { method: 'TRACE', type: 'is-info' }];
        case 'https://w3id.org/idsa/code/WRITE':
          return [{ method: 'POST', type: 'is-success' }];
        case 'https://w3id.org/idsa/code/MODIFY':
          return [{ method: 'PUT', type: 'is-warning' }, { method: 'PATCH', type: 'is-warning' }];
        case 'https://w3id.org/idsa/code/DELETE':
          return [{ method: 'DELETE', type: 'is-danger' }];
        default:
          return [];
      }
    }).reduce((acc, val) => acc.concat(val), []);
  }
}
</script>